![saplings](https://github.com/kanopi/saplings/assets/5177009/a6377e32-deb2-49d8-873a-f3dd5a36fa7c)

# Saplings CKEditor

## Overview

Configures a rich CKEditor 5 experience optimized for structured content
editing, advanced linking, accessibility, and editorial convenience.


## Features & Customization Highlights

- **Headings**: Includes H2–H6 options for semantic content structure.
- **Lists**: Supports advanced features like list reversal and start indices.
- **Block Styles**: Includes styled blockquotes, author credits, asides, and
  Bootstrap-styled buttons.
- **Alignment**: Enables left, center, and right text alignment.
- **Bootstrap Grid**: Integrates responsive Bootstrap 5 columns (1–6 cols, sm–lg
  breakpoints) using CDN.
- **WProofreader**: Live grammar and spellcheck in both free and premium modes.
- **Link Attributes**: Extend links with ARIA, class, rel, and title attributes.
- **Source Editing**: Whitelists safe HTML elements for advanced users.
- **Media Management**: Inline modal editing and configuration to preserve view
  modes.
- **Linkit**: Uses `saplings_default` profile for intelligent entity
  linking.


## CKEditor Plugins and Free Premium Plugins

Thanks to the folks at CKSource, the maintainers of CKEditor, we are able to
include free plugins for the Drupal CKEditor.  They are:

- **Bookmark** – Allows users to insert bookmarks within content for easier
  navigation.
- **Find and Replace** – Adds advanced find-and-replace functionality with a
  dialog-based UI.

- **Indent Block** – Enables indentation of content blocks, useful for layouts
  and nested structures.
- **Paste Markdown** – Allows pasting Markdown text and auto-converting it to
  structured HTML.
- **Select All** – Adds a toolbar button to select all content in the editor.
- **To Do List** – Enables checkable to-do style lists in documents.
- **Word Count** – Displays word count metadata in the editor toolbar.
- **Fullscreen (Free Premium Plugin)** – Provides a distraction-free fullscreen
  editing mode.
- **WProofreader grammar and spell checker (Free version)** – Provides
  integrated grammar and spellchecking support via WProofreader.


## Toolbar Layout
```
Undo, Redo, Headings, Styles
Bold, Italic, Alignment
Bulleted/Numbered Lists, Todo List, Indent/Outdent
Link, Media, Blockquote, Bookmark, Bootstrap Grid, Tables
Source Editing, Remove Format, Select All, Find & Replace, WProofreader, Fullscreen
```


## Requirements
- Drupal 10.4 or newer (compatible with Drupal 11).
- Included module: `office_hours`.


## Existing sites and future applications.

Currently, this recipe includes an editor and filter format called `full_html`.

Most existing sites will have an editor/format called the same. If you apply the
recipe to a site that has it, the creation of our config will be skipped.

You will have all of the modules installed and enabled, you will just need to
manually configure the editor.

Once [existing config actions issues](https://www.drupal.org/project/issues/search/drupal?text=&assigned=&submitted=&project_issue_followers=&issue_tags_op=%3D&issue_tags=Config+Actions)
in the editor.module and ckeditor.module are added, we will be able to update
this recipe to require Drupal core's full_html recipe, and alter it. Until then
A little manual work needs to be done when applying this recipe on an existing
site.


## Maintainers

Current maintainers:
 * [thejimbirch](https://www.drupal.org/u/thejimbirch)

This project is sponsored by:
 * [Kanopi studios](https://www.drupal.org/kanopi-studios)
